#!/usr/bin/env bash

set -e

# Path to source directory containing all installation files
SRC_DIR=$1

# Path to root destination directory into which files will be installed. By
# default this is the root file system
DEST_DIR=${2:-/}

# Install broadshield
install -d -m 0755 "${DEST_DIR}/usr/bin"
install -D -m 0755 "${SRC_DIR}/broadshield/usr/bin/broadshield" \
        "${DEST_DIR}/usr/bin"
install -d -m 0755 "${DEST_DIR}/usr/lib/broadshield/plugins"
install -d -m 0755 "${DEST_DIR}/usr/lib/broadshield/receivers"
install -m 755 "${SRC_DIR}/broadshield/usr/lib/"*.so* "${DEST_DIR}/usr/lib"
install -m 755 "${SRC_DIR}/broadshield/usr/lib/broadshield/plugins/"*.so \
        "${DEST_DIR}/usr/lib/broadshield/plugins"
install -m 755 "${SRC_DIR}/broadshield/usr/lib/broadshield/receivers/"*.so \
        "${DEST_DIR}/usr/lib/broadshield/receivers"
install -D -m 0644 "${SRC_DIR}/broadshield/etc/xdg/Talen-X/BroadShield.ini" \
        "${DEST_DIR}/etc/xdg/Talen-X/BroadShield.ini"
install -D -m 0644 "${SRC_DIR}/broadshieldid.txt" \
        "${DEST_DIR}/usr/share/broadshield/broadshieldid.txt"

# Install broadshield systemd services
install -D -m 644 "${SRC_DIR}/service/broadshield.service" \
        "${DEST_DIR}/usr/lib/systemd/system/broadshield.service"
install -D -m 644 "${SRC_DIR}/service/broadshield-license.service" \
        "${DEST_DIR}/usr/lib/systemd/system/broadshield-license.service"
install -m 0775 "${SRC_DIR}/service/broadshield-clean.sh" \
        "${DEST_DIR}/usr/bin/broadshield-clean.sh"
install -D -m 0644 "${SRC_DIR}/service/broadshield-clean.service" \
        "${DEST_DIR}/usr/lib/systemd/system/broadshield-clean.service"
install -D -m 0644 "${SRC_DIR}/service/broadshield-clean.timer" \
        "${DEST_DIR}/usr/lib/systemd/system/broadshield-clean.timer"

# Enable broadshield systemd services
systemctl enable broadshield
systemctl enable broadshield-license
systemctl enable broadshield-clean
systemctl enable broadshield-clean.timer
